#************************************************************************
# Codelet Tuning Infrastructure
# Copyright (C) 2010-2015 Intel Corporation, CEA, GENCI, and UVSQ
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#************************************************************************

# Authors: Franck Talbart, Romain Anty

import cti
import ctr

from cti_hapi import plugin, util, submitter, entry, alias
from cti_hapi.main import HapiPlugin, hapi_command
from maqao_decan_util import file_replace, untar

import sys, os, tempfile, json, shutil, stat, subprocess, datetime, glob, tarfile, re

from import_maqao_decan_results import import_results

class MaqaoDecanPlugin(HapiPlugin):
    @hapi_command("init")
    def init_cmd(self, params):
        """ Initializes information for maqao_decan.
            Fills the MAQAO-DECAN configuration file with the given arguments and generates the corresponding experience directory.
            The configuration file and the experiment directory are inserted in a new maqao_decan entry.

        Args:
            self: class of the plugin
            params: working parameters

        Returns:
            Nothing
        """

        #Constants
        
        WORK_DIR = tempfile.mkdtemp(suffix="_maqao_decan_init", dir=".")
        
        #Name of the experiment directory generated by MAQAO-DECAN, formatted as follows: decan_YYYY_MM_DD_hh_mm_ss.
        EXPERIMENT_DIR = "decan_*[0-9]-[0-1][0-9]-[0-3][0-9]_[0-2][0-9]-[0-5][0-9]-[0-5][0-9]"
        
        #Path to the common_tools directory where the decan.exp template is located.
        COMMON_TOOLS_DIR = cti.cti_plugin_config_get_value(cti.COMMON_TOOLS_DIR)
        DECAN_TEMPLATE = "decan_template.exp"


        #Checking MAQAO installation.
        MAQAO_DIR = os.path.join(cti.cti_plugin_config_get_value(cti.THIRD_PARTY_DIR), "maqao")
        if not os.path.isdir(MAQAO_DIR):
            util.cti_plugin_print_error("MAQAO is not installed\nYou can find the tool here: http://www.maqao.org/\n")
            util.cti_plugin_print_error("Install the tool in the third-party directory (third-party/maqao/).\n")
            exit(cti.CTI_PLUGIN_ERROR_TOOL_NOT_FOUND)
        MAQAO_BIN = os.path.join(MAQAO_DIR, "maqao")
        
        #Retrieving argument values.
        binary              = params["binary"]
        repository_query    = params["repository_query"]
        query               = params["query"]
        probes              = params["probes"]
        hardware_counters   = params["hardware_counters"]
        frequencies         = params["frequencies"]
        dataset             = params["dataset"]
        exec_dir            = params["exec_dir"]
        repetitions         = params["repetitions"]
        run_cmd             = params["run_cmd"]
        variants            = params["variants"]
        pinned_core         = params["pinned_core"]
        loop_uids           = params["loops"]
        query_uid           = params["query_uid"]
        maqao_vprof_uid     = params["maqao_vprof_uid"]
        binary_plugin_uid   = params["binary_plugin_uid"]
        auto_run            = params["auto_run"]

        #Checking arguments.
        for probe in probes:
            if probe not in ["hc", "time", "count"]:
                util.cti_plugin_print_error("Unknown probe {0}.\n".format(probe))
                exit(cti.CTI_PLUGIN_ERROR_INVALID_ARGUMENTS)
        
        if "hc" not in probes and hardware_counters:
            util.cti_plugin_print_error("hc probe must be set to analyze hardware counters.\n")
            exit(cti.CTI_PLUGIN_ERROR_INVALID_ARGUMENTS)

        for variant in variants.keys():
            if variant not in ["REF", "LS", "FP", "DL1", "FES", "FES_DEL"]:
                util.cti_plugin_print_error("Unknown variant {0}.\n".format(variant))
                exit(cti.CTI_PLUGIN_ERROR_INVALID_ARGUMENTS)

        #Retrieving the profiler used to profile the binary.
        (_, binary_output_data) = entry.load_data(binary)
        profiler = None

        if binary_output_data["init"].params["maqao_perf_entry"][cti.META_ATTRIBUTE_VALUE]:
            profiler = "maqao_perf"
        elif binary_output_data["init"].params["icc_profiler_entry"][cti.META_ATTRIBUTE_VALUE]:
            profiler = "icc_profiler"

        if not profiler:
            util.cti_plugin_print_error("The binary has not been profiled yet.\n")
            exit(cti.CTI_PLUGIN_ERROR_INVALID_ARGUMENTS)

        #Preparing the user query.
        #Restricting the query to the loops relative to the given binary.
        #If no query was specified, we get all the loops from the given binary.
        if query:
            query += " AND loop_group.{0}.binary.entry_uid:{1}".format(profiler, binary)
        else:
            query = "loop_group.{0}.binary.entry_uid:{1}".format(profiler, binary)
       
        json_file = \
        {
            "select":
            {
                "attributes": {cti.META_ATTRIBUTE_NAME : "select"},
                "params":
                [
                    {cti.META_ATTRIBUTE_NAME : "repository",cti.META_ATTRIBUTE_VALUE : repository_query},
                    {cti.META_ATTRIBUTE_NAME : "query",cti.META_ATTRIBUTE_VALUE : query},
                    {cti.META_ATTRIBUTE_NAME : "type",cti.META_ATTRIBUTE_VALUE : "loop"},
                    {cti.META_ATTRIBUTE_NAME : "format",cti.META_ATTRIBUTE_VALUE : "json"},
                    {cti.META_ATTRIBUTE_NAME : "fields",cti.META_ATTRIBUTE_VALUE : ['entry_uid']},
                    {cti.META_ATTRIBUTE_NAME : "pagination",cti.META_ATTRIBUTE_VALUE : False},
                    {cti.META_ATTRIBUTE_NAME : "size",cti.META_ATTRIBUTE_VALUE : None}
                ]
            }
        }

        #Executing the user query and getting the corresponding loops to analyze.
        loops_query_result = ""
        try:
            loops_query_result = plugin.execute_plugin_by_file(query_uid, json_file, self.username, self.password)
        #We can not be more specific since the above method raises an "Exception" if something goes wrong.
        except Exception:
            print(sys.exc_info()[1])
            exit(cti.CTI_PLUGIN_ERROR_UNEXPECTED)

        loops = json.loads(loops_query_result)
        
        #List of the loop UIDs to analyze, retrieved from the result of the user query.
        query_loop_uids = []
        for loop_uid in loops["data"]:
            (_, loop_output_data) = entry.load_data(cti.CTI_UID(str(loop_uid["entry_uid"])))
            loop_language = loop_output_data["init"].params["language"][cti.META_ATTRIBUTE_VALUE]
            
            #Eliminating special loops inserted by the compiler which can not be profiled by MAQAO-VPROF.
            if loop_language:
                query_loop_uids.append(str(loop_uid["entry_uid"]))

        #Aborting the experience if no loops have been found.
        if not query_loop_uids and not loop_uids:
            util.cti_plugin_print_error("No loops to analyze. Please verify your query and make sure your binary contains at least one loop.\n")
            exit(cti.CTI_PLUGIN_ERROR_INVALID_ARGUMENTS)

        #Concatenating the query results to the loops list.
        #Converting each result into a loop UID.
        array_uid = map(cti.CTI_UID, query_loop_uids)
        loop_uids += array_uid
        self.output_params["init"].params["loops"][cti.META_ATTRIBUTE_VALUE] = loop_uids


        #Filling the MAQAO-DECAN configuration file.
        #TODO: Moving this part in a function of the maqao_decan_util.py file would allow to improve readability of this main file.

        #Initializing placeholders replacement values.
        placeholder_binary_value            = ""
        placeholder_loops_value             = ""
        placeholder_probes_value            = ""
        placeholder_hardware_counters_value = ""
        placeholder_frequencies_value       = ""
        placeholder_variants_value          = ""

        #Filling placeholders...

        #Binary placeholder.
        (_, binary_output_data) = entry.load_data(binary)
        binary_name = binary_output_data["init"].params["binary_file"][cti.META_ATTRIBUTE_VALUE]
        placeholder_binary_value = binary_name.replace(".tar.gz", "")
        
        #Loops placeholder.

        #Running the maqao_vprof plugin on all the loops with an unknown instances count to get it.
        #Note: this will not work if the binary requires a prefix script to be executed.
        loops_to_profile_with_vprof = []

        for loop_uid in loop_uids:
            (_, loop_output_data) = entry.load_data(loop_uid)

            if not loop_output_data["init"].params["invocations"][cti.META_ATTRIBUTE_VALUE]:
                loops_to_profile_with_vprof.append(loop_uid)

        if loops_to_profile_with_vprof:
            util.cti_plugin_print_warning("Your binary has not been profiled with MAQAO-VPROF. Process will continue but may be hazardous. In case of failure, please profile your binary with MAQAO-VPROF before calling MAQAO-DECAN.\n")

            json_file = \
            {
                "init":
                {
                    "attributes": {cti.META_ATTRIBUTE_NAME : "init"},
                    "params":
                    [
                        {cti.META_ATTRIBUTE_NAME : "binary", cti.META_ATTRIBUTE_VALUE : binary},
                        {cti.META_ATTRIBUTE_NAME : "loops", cti.META_ATTRIBUTE_VALUE : loops_to_profile_with_vprof}
                    ]
                }
            }
            
            try:
                loops_query_result = plugin.execute_plugin_by_file(maqao_vprof_uid, json_file, self.username, self.password)
            #We can not be more specific since the above method raises an "Exception" if something goes wrong.
            except Exception:
                print(sys.exc_info()[1])
                exit(cti.CTI_PLUGIN_ERROR_UNEXPECTED)

        #Now, the invocations field of each loop is filled.
        for loop_uid in loop_uids:
            (_, loop_output_data) = entry.load_data(loop_uid)
            
            maqao_loop_id = loop_output_data["init"].params["loop_id"][cti.META_ATTRIBUTE_VALUE]
            instances_count = loop_output_data["init"].params["invocations"][cti.META_ATTRIBUTE_VALUE]

            #For each loop, we keep three significant invocations.
            #This is still arbitrary but will be handled by MAQAO-DECAN in future versions.
            instances = []
            instances.append(int((25 * instances_count) / 100) + 1)
            instances.append(int((50 * instances_count) / 100) + 1)
            instances.append(int((75 * instances_count) / 100) + 1)
            
            instances_text = ", ".join("{0}".format(i) for i in instances)

            #Building the loops placeholder loop by loop.
            #Braces have to be doubled to be printed literally.
            placeholder_loops_value += "\t{{id = {0}, instances = {{{1}}}}},\n".format(maqao_loop_id, instances_text)

        #Probes placeholder.
        placeholder_probes_value = ", ".join("\"{0}\"".format(p) for p in probes)

        #Hardware counters placeholder.
        for hardware_counter, sudo_mode in hardware_counters.iteritems():
            if sudo_mode:
                placeholder_hardware_counters_value += "\n\t{{names = \"{0}\", sudo_mode = true}},".format(hardware_counter)
            else:
                placeholder_hardware_counters_value += "\n\t{{names = \"{0}\"}},".format(hardware_counter)
        
        #Frequencies placeholder.
        placeholder_frequencies_value = ", ".join("{0}".format(f) for f in frequencies)

        #Variants placeholder.

        #Used to store the generated variants configuration texts.
        variants_text = []

        for variant, variant_params in variants.iteritems():
            variant_text = "\t\tname = \"{0}\",\n".format(variant)

            for param, value in variant_params.iteritems():
                value_text = ""
                
                #The value of a variant parameter must be surrounded by quotes if it is a string
                #and should be true of false (without quotes and full lowercase) if it is a boolean.
                if isinstance(value, bool):
                    if value:
                        value_text = "true"
                    else:
                        value_text = "false"
                else:
                    value_text = "\"{0}\"".format(value)

                variant_text += "\t\t{0} = {1},\n".format(param, value_text)

            variants_text.append(variant_text)

        #Joining all the generated configuration texts and surrounding them by braces.
        placeholder_variants_value = "\t{{\n{0}\t}}".format("\t},\n\t{\n".join(variants_text))

        #Switching the working directory to the temporary directory to avoid pollution of the user repository with temporary init files.
        user_repository = os.getcwd()
        os.chdir(WORK_DIR)
        
        #Getting the DECAN configuration template file and filling it with all the argument values.
        decan_template_path = os.path.join(os.getcwd(), DECAN_TEMPLATE)
        shutil.copy(os.path.join(COMMON_TOOLS_DIR, DECAN_TEMPLATE), decan_template_path)

        file_replace(
            DECAN_TEMPLATE,
            [
                ("#__CTI_PLACEHOLDER_BINARY_PATH__#", placeholder_binary_value),
                ("#__CTI_PLACEHOLDER_LOOPS__#", placeholder_loops_value),
                ("#__CTI_PLACEHOLDER_PROBES__#", placeholder_probes_value),
                ("#__CTI_PLACEHOLDER_HARDWARE_COUNTERS__#", placeholder_hardware_counters_value),
                ("#__CTI_PLACEHOLDER_FREQUENCIES__#", placeholder_frequencies_value),
                ("#__CTI_PLACEHOLDER_DATASET__#", dataset),
                ("#__CTI_PLACEHOLDER_EXEC_DIR__#", exec_dir),
                ("#__CTI_PLACEHOLDER_REPETITIONS__#", str(repetitions)),
                ("#__CTI_PLACEHOLDER_RUN_CMD__#", run_cmd),
                ("#__CTI_PLACEHOLDER_VARIANTS__#", placeholder_variants_value),
                ("#__CTI_PLACEHOLDER_PINNED_CORE__#", str(pinned_core))
            ]
        )

        #Retrieving the binary from the entry (needed for the experiment generation).
        entry.get_file_from_entry(binary, binary_name, False)

        #Extracting the binary.
        untar(binary_name)

        #Running MAQAO-DECAN to generate the experiment directory.
        maqao_decan_cmd = "{0} decan --generate --config={1}".format(MAQAO_BIN, DECAN_TEMPLATE)

        file_cmd_path = os.path.join(os.getcwd(), "file_cmd.sh")
        file_cmd = open(file_cmd_path, "w")
        file_cmd.write("#!/bin/bash\n")
        file_cmd.write(maqao_decan_cmd + '\n')
        file_cmd.close()
        os.chmod(file_cmd_path, stat.S_IXUSR | stat.S_IRUSR)

        (std_out, std_err) = subprocess.Popen([file_cmd_path], stdout=subprocess.PIPE, stderr=subprocess.PIPE).communicate()

        #Saving the MAQAO-DECAN output (will be inserted in the entry).
        maqao_decan_output_path = os.path.join(os.getcwd(), "maqao_decan_init_output.log")
        maqao_decan_output_file = open(maqao_decan_output_path, "w")
        maqao_decan_output_file.write("stdout:" + '\n')
        maqao_decan_output_file.write("================================================================================" + '\n')
        maqao_decan_output_file.write(std_out + '\n')
        maqao_decan_output_file.write("stderr:" + '\n')
        maqao_decan_output_file.write("================================================================================" + '\n')
        maqao_decan_output_file.write(std_err + '\n')
        maqao_decan_output_file.write("End of file.")
        maqao_decan_output_file.close()

        #Archiving the experiment directory.
        try:
            directory_name = glob.glob(EXPERIMENT_DIR)[0]
        except IndexError:
            util.cti_plugin_print_error("MAQAO-DECAN could not be run. Please check your MAQAO installation.\n")
            exit(cti.CTI_PLUGIN_ERROR_TOOL_NOT_FOUND)

        archive_name = directory_name + ".tar.gz"

        tar = tarfile.open(archive_name, "w:gz")
        tar.add(directory_name)
        tar.close()

        #Switching back to the user repository to create the entry.
        os.chdir(user_repository)

        #Retrieving all patched binaries generated by MAQAO-DECAN and creating the associated binary entries.
        patched_binaries_uids = []

        for patched_binary in os.listdir(os.path.join(WORK_DIR, directory_name, "binaries")):
            if placeholder_binary_value in patched_binary:
                #Retrieving the compile entry from the original binary.
                compile_entry = binary_output_data["init"].params["compile"][cti.META_ATTRIBUTE_VALUE]

                json_file = \
                {
                    "init":
                    {
                        "attributes": {cti.META_ATTRIBUTE_NAME : "init"},
                        "params":
                        [
                            {cti.META_ATTRIBUTE_NAME : "binary_file",cti.META_ATTRIBUTE_VALUE : os.path.join(WORK_DIR, directory_name, "binaries", patched_binary)},
                            {cti.META_ATTRIBUTE_NAME : "compile",cti.META_ATTRIBUTE_VALUE : compile_entry},
                        ]
                    }
                }

                try:
                    binary_execution_result = plugin.execute_plugin_by_file(
                        binary_plugin_uid, json_file, self.username, self.password)
                #We can not be more specific since the above method raises an "Exception" if something goes wrong.
                except Exception:
                    print(sys.exc_info()[1])
                    exit(cti.CTI_PLUGIN_ERROR_UNEXPECTED)
               
                #Retrieving UID of the created entry and adding it to the list of binary variants.
                patched_binary_uid = re.search(
                    "[a-f0-9]{8}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{4}-[a-f0-9]{12}", binary_execution_result).group(0)
                patched_binaries_uids.append(cti.CTI_UID(patched_binary_uid))

        self.output_params["init"].params["binary_variants"][cti.META_ATTRIBUTE_VALUE] = patched_binaries_uids
        
        #Creating entry alias.
        binary_alias = alias.get_data_alias(binary)
        if not binary_alias:
            binary_alias = ""

        now = datetime.datetime.now()
        date = now.strftime("%Y_%m_%d_%H:%M:%S:%f")
        entry_alias = "MAQAO_DECAN_{0}_{1}".format(binary_alias, date)

        #Calling default constructor.
        entry_data = self.default_init_command(params, alias_e=entry_alias)

        #UID of the new entry.
        entry_uid = entry_data.uid

        #Inserting the log file in the new entry.
        try:
            init_log_file = entry.put_file_in_entry(entry_uid, maqao_decan_output_path, False)
        except IOError:
            util.cti_plugin_print_error("No such file {0}\n".format(maqao_decan_output_path))
        
        #Inserting the experiment file in the new entry.
        try:
            experiment_file = entry.put_file_in_entry(entry_uid, decan_template_path, False)
        except IOError:
            util.cti_plugin_print_error("No such file {0}\n".format(decan_template_path))

        #Inserting the experiment directory in the new entry.
        try:
            experiment_directory = entry.put_file_in_entry(entry_uid, os.path.join(WORK_DIR, archive_name))
        except IOError:
            util.cti_plugin_print_error("No such directory {0}\n".format(os.path.join(WORK_DIR, archive_name)))

        entry.update_entry_parameter(
            entry_uid,
            {
                "logs"                  : {"value" : [init_log_file], "append" : True},
                "experiment_file"       : {"value" : experiment_file},
                "experiment_directory"  : {"value" : experiment_directory}
            })

        #Cleaning the user repository.
        shutil.rmtree(WORK_DIR)

        #Running plugin if auto_run is true.
        plugin.plugin_auto_run(self, entry_data, None, auto_run)

    #---------------------------------------------------------------------------

    @hapi_command("run")
    def run_cmd(self, params):
        """ Runs MAQAO-DECAN analysis.

        Args:
            self: class of the plugin
            params: working parameters

        Returns:
            Nothing
        """

        #Constants
        WORK_DIR = cti.cti_plugin_config_get_value(cti.CTI_PLUGIN_WORKING_DIR)
        COMMON_TOOLS_DIR = cti.cti_plugin_config_get_value(cti.COMMON_TOOLS_DIR)

        #Checking MAQAO installation.
        MAQAO_DIR = os.path.join(cti.cti_plugin_config_get_value(cti.THIRD_PARTY_DIR), "maqao")
        if not os.path.isdir(MAQAO_DIR):
            util.cti_plugin_print_error("MAQAO is not installed\nYou can find the tool here: http://www.maqao.org/\n")
            util.cti_plugin_print_error("Install the tool in the third-party directory (third-party/maqao/).\n")
            exit(cti.CTI_PLUGIN_ERROR_TOOL_NOT_FOUND)

        #Retrieving argument values.
        maqao_decan_uid = params["entry"]
        (_, output_params) = entry.load_data(maqao_decan_uid)

        prefix                  = params["prefix"]
        maqao_decan_group_uid   = params["maqao_decan_group_plugin_uid"]
        maqao_decan_results_uid = params["maqao_decan_results_plugin_uid"]
        
        binary                  = output_params["init"].params["binary"][cti.META_ATTRIBUTE_VALUE]
        experiment_directory    = output_params["init"].params["experiment_directory"][cti.META_ATTRIBUTE_VALUE]
        mode                    = output_params["init"].params["mode"][cti.META_ATTRIBUTE_VALUE]
        partition               = output_params["init"].params["partition"][cti.META_ATTRIBUTE_VALUE]
        platform                = output_params["init"].params["platform"][cti.META_ATTRIBUTE_VALUE]
        prefix_execute_script   = output_params["init"].params["prefix_execute_script"][cti.META_ATTRIBUTE_VALUE]
        suffix_execute_script   = output_params["init"].params["suffix_execute_script"][cti.META_ATTRIBUTE_VALUE]
        submitter_cmd           = output_params["init"].params["submitter_cmd"][cti.META_ATTRIBUTE_VALUE]
        submitter_opt           = output_params["init"].params["submitter_opt"][cti.META_ATTRIBUTE_VALUE]
        submitter_user          = output_params["init"].params["submitter_user"][cti.META_ATTRIBUTE_VALUE]
        special_permissions     = output_params["init"].params["special_permissions"][cti.META_ATTRIBUTE_VALUE]

        #Gathering information for the submitter call (allows to execute the plugin on a distant machine).

        #Getting the compiled application path from the binary entry.
        (_, binary_data) = entry.load_data(binary)
        compile_uid = binary_data["init"].params["compile"][cti.META_ATTRIBUTE_VALUE]
        compiled_application_path = None

        if compile_uid:
            (_, compile_data) = entry.load_data(compile_uid)
            compiled_application = compile_data["init"].params["compiled_application"][cti.META_ATTRIBUTE_VALUE]

            if compiled_application:
                compiled_applicaion_path = os.path.join(
                    ctr.ctr_plugin_get_path_by_uid(cti.CTR_ENTRY_DATA, compile_uid),
                    cti.cti_plugin_config_get_value(cti.CTR_ENTRY_FILES_DIR),
                    compiled_application)

        #Creating arguments for the submitter call.

        #Options dictionary used by the submitter.
        dict_opt = {}
        
        dict_opt["APP"] = [os.path.join(
            ctr.ctr_plugin_get_path_by_uid(cti.CTR_ENTRY_DATA, maqao_decan_uid),
            cti.cti_plugin_config_get_value(cti.CTR_ENTRY_FILES_DIR),
            experiment_directory)]
        
        dict_opt["TOOL"] = [MAQAO_DIR]
        if prefix:
            prefix_script_path = os.path.join(tempfile.mkdtemp(), "prefix.sh")
            shutil.copy(prefix, prefix_script_path)
            dict_opt["SCRIPTS"] = [prefix_script_path]
        
        dict_opt["OTHER"] = [
            os.path.join(COMMON_TOOLS_DIR, "libmaqao.so"),
            os.path.join(COMMON_TOOLS_DIR, "libdecanrt.so"),
            os.path.join(COMMON_TOOLS_DIR, "perfeval_c.so")]
        
        if compiled_application_path:
            dict_opt["OTHER"].append(compiled_application_path)
        
        dict_opt["platform"] = platform
        dict_opt["entry"] = maqao_decan_uid
        dict_opt["plugin_execute_script"] = os.path.join(self.plugin_directory, "execute_maqao_decan.py")
        dict_opt["partition"] = partition
        dict_opt["submitter_cmd"] = submitter_cmd
        dict_opt["submitter_opt"] = submitter_opt
        dict_opt["submitter_user"] = submitter_user
        dict_opt["prefix_execute_script"] = prefix_execute_script
        dict_opt["suffix_execute_script"] = suffix_execute_script
        dict_opt["username"] = self.username
        dict_opt["password"] = self.password

        #Creating the script parameters file used by the submitter.
        dict_opt["script_params"] = tempfile.mkstemp(dir=WORK_DIR)[1]

        script_params_file = open(dict_opt["script_params"], "w")
        if not compiled_application_path:
            compiled_application_path = ""
        script_params_file.write(compiled_application_path + '\n')
        script_params_file.write(str(special_permissions) + '\n')
        script_params_file.close()

        #Executing plugin via the submitter.
        print("Calling MAQAO-DECAN. This may take a while depending on the experiment and the number of runs.\n")

        try:
            (job_dir, daemon_log_file_path) = submitter.submitter(dict_opt, self.plugin_uid, mode)
        except OSError:
            cti.cti_plugin_print_warning("The experiment has failed. Results will be collected but may be hazardous.\n")

        #Collecting execution log file.
        execution_log_file_path = None
        for f in glob.glob("*.out"):
            if f != daemon_log_file_path:
                execution_log_file_path = os.path.abspath(f)

        #Enriching the options dictionary with the needed arguments for the import_results script.

        experiment_directory = experiment_directory.replace(".tar.gz", "")

        dict_opt["result_dir"] = os.path.join(WORK_DIR, job_dir + "_local", job_dir, experiment_directory, "cti_results")
        dict_opt["execution_log"] = execution_log_file_path
        dict_opt["daemon_log"] = daemon_log_file_path
        dict_opt["maqao_decan_group_uid"] = maqao_decan_group_uid
        dict_opt["maqao_decan_results_uid"] = maqao_decan_results_uid
        
        #The resulting message to be written in the daemon log file.
        daemon_message = ""

        #Current date to be written in the log file.
        date = datetime.datetime.now().strftime("%Y%m%d_%H%M%S_%f")

        daemon_log_file = open(daemon_log_file_path, "a")

        import_message = "[{0}] Importing results into CTI...".format(date)
        print(import_message)
        daemon_message += import_message
        daemon_log_file.write(daemon_message)
        daemon_log_file.close()

        import_results(dict_opt)

        #Cleaning temporary files.
        shutil.rmtree(os.path.join(WORK_DIR, job_dir + "_local"))

#---------------------------------------------------------------------------

# main function
if __name__ == "__main__":
    p = MaqaoDecanPlugin()
    exit(p.main(sys.argv))
